<?php

// $Id: Social Score $

/**
 * @file
 */

/**
 * Admin settings for socialscore.
 */
function socialscore_form(&$form) {

  $form = array();

  //Checkboxes with available content types
  $form['socialscore_content_types'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Content Types'),
    '#options' => node_get_types('names'),
    '#description' => t('Select the content types, which you want to enable social score.'),
    '#default_value' => variable_get('socialscore_content_types', array()),
  );

  //Seconds for url's statistics expiration
  $form['socialscore_seconds'] = array(
    '#type' => 'textfield',
    '#title' => t('How often do you want to synchronize your content'),
    '#maxlength' => 4,
    '#size' => 4,
    '#default_value' => variable_get('socialscore_seconds', '60'),
    '#description' => t('Time is in seconds.'),
  );

  //If the path module is enabled, show this
  if (module_exists('path')) {
    $form['socialscore_alias'] = array(
      '#type' => 'radios',
      '#title' => t('Which url do you want to use'),
      '#default_value' => variable_get('socialscore_alias', 'noalias'),
      '#options' => array(
        'noalias' => t('Synchronize the node via drupal\'s default url, for example (node/nid)'),
        'alias' => t('Synchronize the node via url alias, for example (/about)'),
        'both' => t('Synchronize the node via both default url and alias, we sum the score of each url'),
      ),
      '#description' => t('By default is Drupal\'s default url.') //ToDo: Write a description
    );
  }

  //Select Sql limit
  $form['socialscore_sql_limit'] = array(
    '#type' => 'textfield',
    '#title' => t('SQL limit for sychronization'),
    '#maxlength' => 4,
    '#size' => 4,
    '#default_value' => variable_get('socialscore_sql_limit', '500'),
    '#description' => t('Nodes per time.'),
  );


  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
  );

  return $form;
}

/**
 * Submit handler for the admin settings form.
 */
function socialscore_form_submit(&$form, $form_values) {
  variable_set('socialscore_alias', $form_values['values']['socialscore_alias']);
  variable_set('socialscore_seconds', $form_values['values']['socialscore_seconds']);
  variable_set('socialscore_content_types', $form_values['values']['socialscore_content_types']);
  variable_set('socialscore_sql_limit', $form_values['values']['socialscore_sql_limit']);
  variable_set('socialscore_key', drupal_get_token('socialscore-greekteam'));
  drupal_set_message(t('Your settings have been saved...'));
  drupal_set_message(t('You have made changes at social score settings. Please run the ') . l(t('sychronization batch.'), 'admin/settings/social-score/synchronization'), 'warning');
}